## utf8proc 2.7.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.0)

include (utils.cmake)

disallow_intree_builds()

if (POLICY CMP0048)
  cmake_policy (SET CMP0048 NEW)
endif ()
project (utf8proc VERSION 2.7.0 LANGUAGES C)

# This is the ABI version number, which may differ from the
# API version number (defined in utf8proc.h and above).
# Be sure to also update these in Makefile and MANIFEST!
set(SO_MAJOR 2)
set(SO_MINOR 5)
set(SO_PATCH 0)

option(UTF8PROC_INSTALL "Enable installation of utf8proc" On)
option(UTF8PROC_ENABLE_TESTING "Enable testing of utf8proc" Off)
option(LIB_FUZZING_ENGINE "Fuzzing engine to link against" Off)

add_library (utf8proc
  utf8proc.c
  utf8proc.h
)

# expose header path, for when this is part of a larger cmake project
target_include_directories(utf8proc PUBLIC .)

if (BUILD_SHARED_LIBS)
  # Building shared library
else()
  # Building static library
  target_compile_definitions(utf8proc PUBLIC "UTF8PROC_STATIC")
  if (MSVC)
    set_target_properties(utf8proc PROPERTIES OUTPUT_NAME "utf8proc_static")
  endif()
endif()

target_compile_definitions(utf8proc PRIVATE "UTF8PROC_EXPORTS")

if (NOT MSVC)
  set_target_properties(
    utf8proc PROPERTIES
    COMPILE_FLAGS "-O2 -std=c99 -pedantic -Wall"
  )
endif ()

set_target_properties (utf8proc PROPERTIES
  POSITION_INDEPENDENT_CODE ON
  VERSION "${SO_MAJOR}.${SO_MINOR}.${SO_PATCH}"
  SOVERSION ${SO_MAJOR}
)

if (UTF8PROC_INSTALL)
  include(GNUInstallDirs)
  install(FILES utf8proc.h DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
  install(TARGETS utf8proc
    ARCHIVE DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}"
  )
  configure_file(libutf8proc.pc.cmakein libutf8proc.pc @ONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libutf8proc.pc" DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")
endif()

if(UTF8PROC_ENABLE_TESTING)
  enable_testing()
  file(MAKE_DIRECTORY data)
  set(UNICODE_VERSION 14.0.0)
  file(DOWNLOAD https://www.unicode.org/Public/${UNICODE_VERSION}/ucd/NormalizationTest.txt ${CMAKE_BINARY_DIR}/data/NormalizationTest.txt SHOW_PROGRESS)
  file(DOWNLOAD https://www.unicode.org/Public/${UNICODE_VERSION}/ucd/auxiliary/GraphemeBreakTest.txt ${CMAKE_BINARY_DIR}/data/GraphemeBreakTest.txt SHOW_PROGRESS)
  add_executable(case test/tests.h test/tests.c utf8proc.h test/case.c)
  target_link_libraries(case utf8proc)
  add_executable(custom test/tests.h test/tests.c utf8proc.h test/custom.c)
  target_link_libraries(custom utf8proc)
  add_executable(iterate test/tests.h test/tests.c utf8proc.h test/iterate.c)
  target_link_libraries(iterate utf8proc)
  add_executable(misc test/tests.h test/tests.c utf8proc.h test/misc.c)
  target_link_libraries(misc utf8proc)
  add_executable(printproperty test/tests.h test/tests.c utf8proc.h test/printproperty.c)
  target_link_libraries(printproperty utf8proc)
  add_executable(valid test/tests.h test/tests.c utf8proc.h test/valid.c)
  target_link_libraries(valid utf8proc)
  add_test(utf8proc.testcase case)
  add_test(utf8proc.testcustom custom)
  add_test(utf8proc.testiterate iterate)
  add_test(utf8proc.testmisc misc)
  add_test(utf8proc.testprintproperty printproperty)
  add_test(utf8proc.testvalid valid)

  if (NOT WIN32)
    # no wcwidth function on Windows
    add_executable(charwidth test/tests.h test/tests.c utf8proc.h test/charwidth.c)
    target_link_libraries(charwidth utf8proc)
    add_test(utf8proc.testcharwidth charwidth)
  endif()
  add_executable(graphemetest test/tests.h test/tests.c utf8proc.h test/graphemetest.c)
  target_link_libraries(graphemetest utf8proc)
  add_executable(normtest test/tests.h test/tests.c utf8proc.h test/normtest.c)
  target_link_libraries(normtest utf8proc)
  add_test(utf8proc.testgraphemetest graphemetest data/GraphemeBreakTest.txt)
  add_test(utf8proc.testnormtest normtest data/NormalizationTest.txt)

  if(LIB_FUZZING_ENGINE)
    add_executable(fuzzer utf8proc.h test/fuzzer.c)
    target_link_libraries(fuzzer ${LIB_FUZZING_ENGINE} utf8proc)
  else()
    add_executable(fuzzer utf8proc.h test/fuzz_main.c test/fuzzer.c)
    target_link_libraries(fuzzer utf8proc)
  endif()
endif()

=== Makefile ===
# libutf8proc Makefile

# programs
AR?=ar
CC?=gcc
INSTALL=install
FIND=find
PERL=perl

# compiler settings
CFLAGS ?= -O2
PICFLAG = -fPIC
C99FLAG = -std=c99
WCFLAGS = -Wsign-conversion -Wall -Wextra -pedantic
UCFLAGS = $(CPPFLAGS) $(CFLAGS) $(PICFLAG) $(C99FLAG) $(WCFLAGS) -DUTF8PROC_EXPORTS $(UTF8PROC_DEFINES)
LDFLAG_SHARED = -shared
SOFLAG = -Wl,-soname

# shared-library version MAJOR.MINOR.PATCH ... this may be *different*
# from the utf8proc version number because it indicates ABI compatibility,
# not API compatibility: MAJOR should be incremented whenever *binary*
# compatibility is broken, even if the API is backward-compatible.
# The API version number is defined in utf8proc.h.
# Be sure to also update these ABI versions in MANIFEST and CMakeLists.txt!
MAJOR=2
MINOR=5
PATCH=0

OS := $(shell uname)
ifeq ($(OS),Darwin) # MacOS X
  SHLIB_EXT = dylib
  SHLIB_VERS_EXT = $(MAJOR).dylib
else # GNU/Linux, at least (Windows should probably use cmake)
  SHLIB_EXT = so
  SHLIB_VERS_EXT = so.$(MAJOR).$(MINOR).$(PATCH)
endif

# installation directories (for 'make install')
prefix=/usr/local
libdir=$(prefix)/lib
includedir=$(prefix)/include
pkgconfigdir=$(libdir)/pkgconfig

pkglibdir=$(libdir:$(prefix)/%=%)
pkgincludedir=$(includedir:$(prefix)/%=%)

# meta targets

.PHONY: all clean data update manifest install

all: libutf8proc.a libutf8proc.$(SHLIB_EXT)

clean:
	rm -f utf8proc.o libutf8proc.a libutf8proc.$(SHLIB_VERS_EXT) libutf8proc.$(SHLIB_EXT)
	rm -f libutf8proc.pc
ifneq ($(OS),Darwin)
	rm -f libutf8proc.so.$(MAJOR)
endif
	rm -f test/tests.o test/normtest test/graphemetest test/printproperty test/charwidth test/valid test/iterate test/case test/custom test/misc test/iscase
	rm -rf MANIFEST.new tmp
	$(MAKE) -C bench clean
	$(MAKE) -C data clean

data: data/utf8proc_data.c.new

update: data/utf8proc_data.c.new
	cp -f data/utf8proc_data.c.new utf8proc_data.c

manifest: MANIFEST.new

# real targets

data/utf8proc_data.c.new: libutf8proc.$(SHLIB_EXT) data/data_generator.rb data/charwidths.jl
	$(MAKE) -C data utf8proc_data.c.new

utf8proc.o: utf8proc.h utf8proc.c utf8proc_data.c
	$(CC) $(UCFLAGS) -c -o utf8proc.o utf8proc.c

libutf8proc.a: utf8proc.o
	rm -f libutf8proc.a
	$(AR) rs libutf8proc.a utf8proc.o

libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH): utf8proc.o
	$(CC) $(LDFLAGS) $(LDFLAG_SHARED) -o $@ $(SOFLAG) -Wl,libutf8proc.so.$(MAJOR) utf8proc.o
	chmod a-x $@

libutf8proc.so: libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH)
	ln -f -s libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH) $@
	ln -f -s libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH) $@.$(MAJOR)

libutf8proc.$(MAJOR).dylib: utf8proc.o
	$(CC) $(LDFLAGS) -dynamiclib -o $@ $^ -install_name $(libdir)/$@ -Wl,-compatibility_version -Wl,$(MAJOR) -Wl,-current_version -Wl,$(MAJOR).$(MINOR).$(PATCH)

libutf8proc.dylib: libutf8proc.$(MAJOR).dylib
	ln -f -s libutf8proc.$(MAJOR).dylib $@

libutf8proc.pc: libutf8proc.pc.in
	sed \
		-e 's#PREFIX#$(prefix)#' \
		-e 's#LIBDIR#$(pkglibdir)#' \
		-e 's#INCLUDEDIR#$(pkgincludedir)#' \
		-e 's#VERSION#$(MAJOR).$(MINOR).$(PATCH)#' \
		libutf8proc.pc.in > libutf8proc.pc

install: libutf8proc.a libutf8proc.$(SHLIB_EXT) libutf8proc.$(SHLIB_VERS_EXT) libutf8proc.pc
	mkdir -m 755 -p $(DESTDIR)$(includedir)
	$(INSTALL) -m 644 utf8proc.h $(DESTDIR)$(includedir)
	mkdir -m 755 -p $(DESTDIR)$(libdir)
	$(INSTALL) -m 644 libutf8proc.a $(DESTDIR)$(libdir)
	$(INSTALL) -m 755 libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)
	mkdir -m 755 -p $(DESTDIR)$(pkgconfigdir)
	$(INSTALL) -m 644 libutf8proc.pc $(DESTDIR)$(pkgconfigdir)/libutf8proc.pc
	ln -f -s libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)/libutf8proc.$(SHLIB_EXT)
ifneq ($(OS),Darwin)
	ln -f -s libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)/libutf8proc.so.$(MAJOR)
endif

MANIFEST.new:
	rm -rf tmp
	$(MAKE) install prefix=/usr DESTDIR=$(PWD)/tmp
	$(FIND) tmp/usr -mindepth 1 -type l -printf "%P -> %l\n" -or -type f -printf "%P\n" -or -type d -printf "%P/\n" | LC_ALL=C sort > $@
	rm -rf tmp

# Test programs

data/NormalizationTest.txt:
	$(MAKE) -C data NormalizationTest.txt

data/GraphemeBreakTest.txt:
	$(MAKE) -C data GraphemeBreakTest.txt

data/Lowercase.txt:
	$(MAKE) -C data Lowercase.txt

data/Uppercase.txt:
	$(MAKE) -C data Uppercase.txt

test/tests.o: test/tests.c test/tests.h utf8proc.h
	$(CC) $(UCFLAGS) -c -o test/tests.o test/tests.c

test/normtest: test/normtest.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/normtest.c test/tests.o utf8proc.o -o $@

test/graphemetest: test/graphemetest.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/graphemetest.c test/tests.o utf8proc.o -o $@

test/printproperty: test/printproperty.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/printproperty.c test/tests.o utf8proc.o -o $@

test/charwidth: test/charwidth.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/charwidth.c test/tests.o utf8proc.o -o $@

test/valid: test/valid.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/valid.c test/tests.o utf8proc.o -o $@

test/iterate: test/iterate.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/iterate.c test/tests.o utf8proc.o -o $@

test/iscase: test/iscase.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/iscase.c test/tests.o utf8proc.o -o $@

test/case: test/case.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/case.c test/tests.o utf8proc.o -o $@

test/custom: test/custom.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) test/custom.c test/tests.o utf8proc.o -o $@

test/misc: test/misc.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) $(LDFLAGS) -DUNICODE_VERSION='"'`$(PERL) -ne "/^UNICODE_VERSION=/ and print $$';" data/Makefile`'"' test/misc.c test/tests.o utf8proc.o -o $@

check: test/normtest data/NormalizationTest.txt data/Lowercase.txt data/Uppercase.txt test/graphemetest data/GraphemeBreakTest.txt test/printproperty test/case test/iscase test/custom test/charwidth test/misc test/valid test/iterate bench/bench.c bench/util.c bench/util.h utf8proc.o
	$(MAKE) -C bench
	test/normtest data/NormalizationTest.txt
	test/graphemetest data/GraphemeBreakTest.txt
	test/charwidth
	test/misc
	test/valid
	test/iterate
	test/case
	test/iscase data/Lowercase.txt data/Uppercase.txt
	test/custom

=== debian/changelog ===
utf8proc (2.7.0-3) unstable; urgency=medium

  * Upstream's Makefile is not parallel-safe,
    build with --no-parallel for now

 -- Graham Inggs <ginggs@debian.org>  Mon, 27 Dec 2021 07:47:18 +0000

utf8proc (2.7.0-2) unstable; urgency=medium

  * Use GraphemeBreakTest.txt as is, re-enable graphemetest
  * Use grep to generate Uppercase.txt and Lowercase.txt
  * Drop build-dependencies on perl and ruby
  * Adapt autopkgtest so it is triggered by changes to unicode-data

 -- Graham Inggs <ginggs@debian.org>  Fri, 24 Dec 2021 06:47:34 +0000

utf8proc (2.7.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Submit.

  [ Graham Inggs ]
  * New upstream release
  * Refresh use-unicode-data.patch
  * Build with unicode-data 14.0 (Closes: #995579)
  * Add build-dependency on ruby
  * Skip graphemetest that never completes
  * Update libutf8proc2.symbols with new symbols from 2.6.0
  * Install the pkgconfig file from libutf8proc-dev.install
    instead of debian/rules
  * Switch to debhelper 13
  * Bump Standards-Version to 4.6.0, no changes

 -- Graham Inggs <ginggs@debian.org>  Tue, 21 Dec 2021 14:29:13 +0000

=== debian/control ===
Source: utf8proc
Priority: optional
Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
Uploaders: Peter Colberg <peter@colberg.org>,
           Graham Inggs <ginggs@debian.org>,
           Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13),
               unicode-data (<< 14.1),
               unicode-data (>= 14.0)
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: libs
Homepage: https://github.com/JuliaStrings/utf8proc
Vcs-Git: https://salsa.debian.org/julia-team/utf8proc.git
Vcs-Browser: https://salsa.debian.org/julia-team/utf8proc

Package: libutf8proc2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C library for processing UTF-8 Unicode data (shared library)
 utf8proc is a small, clean C library that provides Unicode normalization,
 case-folding, and other operations for data in the UTF-8 encoding, supporting
 Unicode version 8.0.
 .
 This package contains a shared version of the library.

Package: libutf8proc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libutf8proc2 (= ${binary:Version}), ${misc:Depends}
Description: C library for processing UTF-8 Unicode data (development files)
 utf8proc is a small, clean C library that provides Unicode normalization,
 case-folding, and other operations for data in the UTF-8 encoding, supporting
 Unicode version 8.0.
 .
 This package contains the development files needed to compile software using
 utf8proc.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install -- prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

## utf8proc 2.8.0

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 # The API version number is defined in utf8proc.h.
 # Be sure to also update these ABI versions in MANIFEST and CMakeLists.txt!
 MAJOR=2
-MINOR=5
+MINOR=6
 PATCH=0
 
 OS := $(shell uname)
@@ -78,7 +78,7 @@
 
 libutf8proc.a: utf8proc.o
 	rm -f libutf8proc.a
-	$(AR) rs libutf8proc.a utf8proc.o
+	$(AR) crs libutf8proc.a utf8proc.o
 
 libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH): utf8proc.o
 	$(CC) $(LDFLAGS) $(LDFLAG_SHARED) -o $@ $(SOFLAG) -Wl,libutf8proc.so.$(MAJOR) utf8proc.o

=== data/Makefile ===
# Unicode data generation rules.  Except for the test data files, most
# users will not use these Makefile rules, which are primarily to re-generate
# unicode_data.c when we get a new Unicode version or charwidth data; they
# require ruby and julia to be installed.

# programs
CURL=curl
RUBY=ruby
PERL=perl
MAKE=make
JULIA=julia
CURLFLAGS = --retry 5 --location

.PHONY: clean

.DELETE_ON_ERROR:

utf8proc_data.c.new: data_generator.rb UnicodeData.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt CharWidths.txt emoji-data.txt
	$(RUBY) data_generator.rb < UnicodeData.txt > $@

CharWidths.txt: charwidths.jl EastAsianWidth.txt
	$(JULIA) charwidths.jl > $@

# Unicode data version (must also update utf8proc_unicode_version function)
UNICODE_VERSION=15.0.0

UnicodeData.txt:
	$(CURL) $(CURLFLAGS) -o $@ https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/UnicodeData.txt

EastAsianWidth.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/EastAsianWidth.txt

GraphemeBreakProperty.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/auxiliary/GraphemeBreakProperty.txt

DerivedCoreProperties.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/DerivedCoreProperties.txt

CompositionExclusions.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/CompositionExclusions.txt

CaseFolding.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/CaseFolding.txt

NormalizationTest.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/NormalizationTest.txt

GraphemeBreakTest.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/auxiliary/GraphemeBreakTest.txt

emoji-data.txt:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://unicode.org/Public/$(UNICODE_VERSION)/ucd/emoji/emoji-data.txt

Uppercase.txt: DerivedCoreProperties.txt
	$(RUBY) -e 'puts File.read("DerivedCoreProperties.txt")[/# Derived Property: Uppercase.*?# Total code points:/m]' > $@

Lowercase.txt: DerivedCoreProperties.txt
	$(RUBY) -e 'puts File.read("DerivedCoreProperties.txt")[/# Derived Property: Lowercase.*?# Total code points:/m]' > $@

clean:
	rm -f UnicodeData.txt EastAsianWidth.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt NormalizationTest.txt GraphemeBreakTest.txt CharWidths.txt emoji-data.txt
	rm -f Uppercase.txt Lowercase.txt
	rm -f utf8proc_data.c.new

=== debian/changelog ===
utf8proc (2.8.0-1) unstable; urgency=medium

  * New upstream version 2.8.0
  * Remove patches for unicode-data 15. No longer needed.
  * Refresh remaining patches.

 -- Mo Zhou <lumin@debian.org>  Wed, 16 Nov 2022 14:03:50 -0500

utf8proc (2.7.0-4) unstable; urgency=medium

  * Bump B-D to Unicode-data 15.0
  * Add patches to support Unicode-data 15.0.0 (Closes: #1019923)

 -- Mo Zhou <lumin@debian.org>  Wed, 21 Sep 2022 10:22:38 -0400

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
            Graham Inggs <ginggs@debian.org>,
            Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               unicode-data (<< 14.1),
-               unicode-data (>= 14.0)
+               unicode-data (<< 15.1),
+               unicode-data (>= 15.0)
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Section: libs

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/utf8proc-$1\.tar\.gz/ \
https://github.com/JuliaStrings/utf8proc/tags .*/v?(\d\S*)\.tar\.gz

## utf8proc 2.9.0

=== Makefile ===
--- 
+++ 
@@ -22,9 +22,12 @@
 # compatibility is broken, even if the API is backward-compatible.
 # The API version number is defined in utf8proc.h.
 # Be sure to also update these ABI versions in MANIFEST and CMakeLists.txt!
-MAJOR=2
-MINOR=6
+MAJOR=3
+MINOR=0
 PATCH=0
+
+# api version (also in utf8proc.h and CMakeLists.txt)
+VERSION=2.9.0
 
 OS := $(shell uname)
 ifeq ($(OS),Darwin) # MacOS X
@@ -168,6 +171,21 @@
 test/misc: test/misc.c test/tests.o utf8proc.o utf8proc.h test/tests.h
 	$(CC) $(UCFLAGS) $(LDFLAGS) -DUNICODE_VERSION='"'`$(PERL) -ne "/^UNICODE_VERSION=/ and print $$';" data/Makefile`'"' test/misc.c test/tests.o utf8proc.o -o $@
 
+# make release tarball from master branch
+dist:
+	git archive master --prefix=utf8proc-$(VERSION)/ -o utf8proc-$(VERSION).tar.gz
+
+# build tarball, make sure it passes checks, and make sure version numbers are consistent
+distcheck: dist
+	test `grep UTF8PROC_VERSION utf8proc.h | cut -d' ' -f3 | tr '\n' .` = $(VERSION). || exit 1
+	test `grep "utf8proc VERSION" CMakeLists.txt |cut -d' ' -f 4` = $(VERSION) || exit 1
+	test `grep  libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH) MANIFEST | wc -l` = 3 || exit 1
+	test `grep 'set(SO_' CMakeLists.txt |cut -d' ' -f2 | tr -d ')' | tr '\n' '.'` = $(MAJOR).$(MINOR).$(PATCH). || exit 1
+	rm -rf utf8proc-$(VERSION)
+	tar xzf utf8proc-$(VERSION).tar.gz
+	make -C utf8proc-$(VERSION) check
+	rm -rf utf8proc-$(VERSION)
+
 check: test/normtest data/NormalizationTest.txt data/Lowercase.txt data/Uppercase.txt test/graphemetest data/GraphemeBreakTest.txt test/printproperty test/case test/iscase test/custom test/charwidth test/misc test/valid test/iterate bench/bench.c bench/util.c bench/util.h utf8proc.o
 	$(MAKE) -C bench
 	test/normtest data/NormalizationTest.txt

=== debian/changelog ===
utf8proc (2.9.0-1build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:58:11 +0200

utf8proc (2.9.0-1) unstable; urgency=medium

  * Upload to unstable and start transition.

 -- Mo Zhou <lumin@debian.org>  Fri, 27 Oct 2023 14:45:19 -0400

utf8proc (2.9.0-1~exp1) experimental; urgency=medium

  * New upstream version 2.9.0 (Closes: #1052835)
    supports unicode-data 15.1.0
  * Refresh remaining patches.
  * Bump SOVERSION from 2 to 3.
  * Discard the --no-parallel dh option.

 -- Mo Zhou <lumin@debian.org>  Sun, 22 Oct 2023 17:18:12 -0400

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: utf8proc
 Priority: optional
-Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
 Uploaders: Peter Colberg <peter@colberg.org>,
            Graham Inggs <ginggs@debian.org>,
            Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               unicode-data (<< 15.1),
-               unicode-data (>= 15.0)
+               unicode-data (<< 15.2),
+               unicode-data (>= 15.1)
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Section: libs
@@ -14,7 +15,7 @@
 Vcs-Git: https://salsa.debian.org/julia-team/utf8proc.git
 Vcs-Browser: https://salsa.debian.org/julia-team/utf8proc
 
-Package: libutf8proc2
+Package: libutf8proc3
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -30,7 +31,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libutf8proc2 (= ${binary:Version}), ${misc:Depends}
+Depends: libutf8proc3 (= ${binary:Version}), ${misc:Depends}
 Description: C library for processing UTF-8 Unicode data (development files)
  utf8proc is a small, clean C library that provides Unicode normalization,
  case-folding, and other operations for data in the UTF-8 encoding, supporting

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --no-parallel
+	dh $@ --buildsystem=makefile
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

## utf8proc 2.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,19 +1,17 @@
-cmake_minimum_required (VERSION 3.0.0)
+cmake_minimum_required (VERSION 3.10)
 
 include (utils.cmake)
 
 disallow_intree_builds()
 
-if (POLICY CMP0048)
-  cmake_policy (SET CMP0048 NEW)
-endif ()
-project (utf8proc VERSION 2.7.0 LANGUAGES C)
+# API version - be sure to update utf8proc.h and Makefile, too!
+project (utf8proc VERSION 2.10.0 LANGUAGES C)
 
 # This is the ABI version number, which may differ from the
 # API version number (defined in utf8proc.h and above).
 # Be sure to also update these in Makefile and MANIFEST!
-set(SO_MAJOR 2)
-set(SO_MINOR 5)
+set(SO_MAJOR 3)
+set(SO_MINOR 1)
 set(SO_PATCH 0)
 
 option(UTF8PROC_INSTALL "Enable installation of utf8proc" On)
@@ -68,7 +66,7 @@
 if(UTF8PROC_ENABLE_TESTING)
   enable_testing()
   file(MAKE_DIRECTORY data)
-  set(UNICODE_VERSION 14.0.0)
+  set(UNICODE_VERSION 16.0.0)
   file(DOWNLOAD https://www.unicode.org/Public/${UNICODE_VERSION}/ucd/NormalizationTest.txt ${CMAKE_BINARY_DIR}/data/NormalizationTest.txt SHOW_PROGRESS)
   file(DOWNLOAD https://www.unicode.org/Public/${UNICODE_VERSION}/ucd/auxiliary/GraphemeBreakTest.txt ${CMAKE_BINARY_DIR}/data/GraphemeBreakTest.txt SHOW_PROGRESS)
   add_executable(case test/tests.h test/tests.c utf8proc.h test/case.c)

=== Makefile ===
--- 
+++ 
@@ -23,11 +23,11 @@
 # The API version number is defined in utf8proc.h.
 # Be sure to also update these ABI versions in MANIFEST and CMakeLists.txt!
 MAJOR=3
-MINOR=0
+MINOR=1
 PATCH=0
 
 # api version (also in utf8proc.h and CMakeLists.txt)
-VERSION=2.9.0
+VERSION=2.10.0
 
 OS := $(shell uname)
 ifeq ($(OS),Darwin) # MacOS X
@@ -73,7 +73,7 @@
 
 # real targets
 
-data/utf8proc_data.c.new: libutf8proc.$(SHLIB_EXT) data/data_generator.rb data/charwidths.jl
+data/utf8proc_data.c.new: libutf8proc.$(SHLIB_EXT) data/data_generator.jl
 	$(MAKE) -C data utf8proc_data.c.new
 
 utf8proc.o: utf8proc.h utf8proc.c utf8proc_data.c

=== data/Makefile ===
--- 
+++ 
@@ -1,11 +1,10 @@
 # Unicode data generation rules.  Except for the test data files, most
 # users will not use these Makefile rules, which are primarily to re-generate
 # unicode_data.c when we get a new Unicode version or charwidth data; they
-# require ruby and julia to be installed.
+# require julia to be installed.
 
 # programs
 CURL=curl
-RUBY=ruby
 PERL=perl
 MAKE=make
 JULIA=julia
@@ -15,14 +14,14 @@
 
 .DELETE_ON_ERROR:
 
-utf8proc_data.c.new: data_generator.rb UnicodeData.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt CharWidths.txt emoji-data.txt
-	$(RUBY) data_generator.rb < UnicodeData.txt > $@
+RAWDATA = UnicodeData.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt EastAsianWidth.txt emoji-data.txt
 
-CharWidths.txt: charwidths.jl EastAsianWidth.txt
-	$(JULIA) charwidths.jl > $@
+utf8proc_data.c.new: data_generator.jl $(RAWDATA)
+	$(JULIA) --project=. -e 'using Pkg; Pkg.instantiate()'
+	$(JULIA) --project=. data_generator.jl > $@
 
 # Unicode data version (must also update utf8proc_unicode_version function)
-UNICODE_VERSION=15.0.0
+UNICODE_VERSION=16.0.0
 
 UnicodeData.txt:
 	$(CURL) $(CURLFLAGS) -o $@ https://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/UnicodeData.txt
@@ -52,12 +51,12 @@
 	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://unicode.org/Public/$(UNICODE_VERSION)/ucd/emoji/emoji-data.txt
 
 Uppercase.txt: DerivedCoreProperties.txt
-	$(RUBY) -e 'puts File.read("DerivedCoreProperties.txt")[/# Derived Property: Uppercase.*?# Total code points:/m]' > $@
+	$(JULIA) -e 'print(match(r"# Derived Property: Uppercase.*?# Total code points:"s, read("DerivedCoreProperties.txt", String)).match)' > $@
 
 Lowercase.txt: DerivedCoreProperties.txt
-	$(RUBY) -e 'puts File.read("DerivedCoreProperties.txt")[/# Derived Property: Lowercase.*?# Total code points:/m]' > $@
+	$(JULIA) -e 'print(match(r"# Derived Property: Lowercase.*?# Total code points:"s, read("DerivedCoreProperties.txt", String)).match)' > $@
 
 clean:
-	rm -f UnicodeData.txt EastAsianWidth.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt NormalizationTest.txt GraphemeBreakTest.txt CharWidths.txt emoji-data.txt
+	rm -f $(RAWDATA) NormalizationTest.txt GraphemeBreakTest.txt
 	rm -f Uppercase.txt Lowercase.txt
 	rm -f utf8proc_data.c.new

=== debian/changelog ===
utf8proc (2.10.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Matthias Geiger <werdahias@debian.org>  Wed, 03 Sep 2025 13:15:04 +0200

utf8proc (2.10.0-1) experimental; urgency=medium

  [ Graham Inggs ]
  * Remove myself from Uploaders
  * Update Maintainer and Uploaders

  [ Matthias Geiger ]
  * d/gbp.conf: Update for DEP-14 style
  * New upstream release (Closes: #1108099)
  * d/control: Take over as maintainer
  * d/control: Bump S-V to 4.7.2, no changes needed
  * d/control: Switch VCS-Urls to /debian namespace
  * Rebase patch for new upstream release
  * d/rules: Drop obsolete buildsystem invocation
  * d/control: Require unicode-data 16.0
  * d/libutf8proc3.symbols: Add new symbol, add Build-Depends
  * d/watch: Switch to v4
  * d/copyright: Update

 -- Matthias Geiger <werdahias@debian.org>  Tue, 02 Sep 2025 19:59:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,14 @@
 Source: utf8proc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
-Uploaders: Peter Colberg <peter@colberg.org>,
-           Graham Inggs <ginggs@debian.org>,
-           Mo Zhou <lumin@debian.org>
+Maintainer: Matthias Geiger <werdahias@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               unicode-data (<< 15.2),
-               unicode-data (>= 15.1)
-Standards-Version: 4.6.0
+               unicode-data (>= 16.0)
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/JuliaStrings/utf8proc
-Vcs-Git: https://salsa.debian.org/julia-team/utf8proc.git
-Vcs-Browser: https://salsa.debian.org/julia-team/utf8proc
+Vcs-Git: https://salsa.debian.org/debian/utf8proc.git
+Vcs-Browser: https://salsa.debian.org/debian/utf8proc
 
 Package: libutf8proc3
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

=== debian/tests/control ===
Test-Command: make -f debian/tests/Makefile
Depends: @, build-essential
Restrictions: allow-stderr, build-needed

Test-Command: /bin/true
Depends: unicode-data
Restrictions: hint-testsuite-triggers

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/utf8proc-$1\.tar\.gz/ \
https://github.com/JuliaStrings/utf8proc/tags .*/v?(\d\S*)\.tar\.gz

## utf8proc 2.11.3

=== debian/changelog ===
utf8proc (2.11.3-1) experimental; urgency=medium

  * New upstream release (Closes: #1125322)
  * d/control: Bump S-V to 4.7.3; drop priority: optional and RRR
  * d/patches: Rebase for new upstream
  * d/control: Require unicode-data 17.0.0
  * d/control: Add Built-Using for binary packages

 -- Matthias Geiger <werdahias@debian.org>  Mon, 12 Jan 2026 16:38:21 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,8 @@
 Source: utf8proc
-Priority: optional
 Maintainer: Matthias Geiger <werdahias@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               unicode-data (>= 16.0)
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+               unicode-data (>= 17.0.0)
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://github.com/JuliaStrings/utf8proc
 Vcs-Git: https://salsa.debian.org/debian/utf8proc.git
@@ -15,6 +13,7 @@
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Built-Using: ${Built-Using}
 Description: C library for processing UTF-8 Unicode data (shared library)
  utf8proc is a small, clean C library that provides Unicode normalization,
  case-folding, and other operations for data in the UTF-8 encoding, supporting
@@ -27,6 +26,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: libutf8proc3 (= ${binary:Version}), ${misc:Depends}
+Built-Using: ${Built-Using}
 Description: C library for processing UTF-8 Unicode data (development files)
  utf8proc is a small, clean C library that provides Unicode normalization,
  case-folding, and other operations for data in the UTF-8 encoding, supporting
